<?php
/***************************************\
|            PHP OPTIMISATEUR           |
|      Plugin CreateCustomThumbs 1.1    |
\***************************************/

## Différents traitements sur les miniatures : taille fixe & cadre (2 couleurs)
## Dépend de la valeur de $CONF['DIMthumbnail']

if(!isset($CCT_filesource)) $CCT_filesource = $FilesSource[$i];                // fichier de travail
$CCT_dimthumbnail = $CONF['Plugins']['create_custom_thumbs']['DIMthumbnailV']; // Hauteur de l'image
$CCT_frameparams = $CONF['Plugins']['create_custom_thumbs']['FRAMEparams'];    // Paramètres du cadre

if (!isset($BlockAll)) {

// CreateCustomThumbs à la priorité sur ConvertPan
if (isset($BlockThumbnail['convert_pan']) OR !isset($BlockThumbnail)) { 
  
  // Miniature de taille personnalisée
  if ($CCT_dimthumbnail != 0) {
    $max = max($CONF['DIMthumbnail'], $CCT_dimthumbnail);

    // on prend la miniature au milieu de l'image
    if ($FileInfos['Height'] >= $FileInfos['Width']) {
      $resize_param = $max.' 0';
      $tmp_x = $max;
      $tmp_y = $max * $FileInfos['Height'] / $FileInfos['Width'];
    } else {
      $resize_param = '0 '.$max;
      $tmp_x = $max * $FileInfos['Width'] / $FileInfos['Height'];
      $tmp_y = $max;
    }
    
    $offset_x = ceil(($tmp_x - $CONF['DIMthumbnail']) / 2);
    $offset_y = ceil(($tmp_y - $CCT_dimthumbnail) / 2);
    
    nconvert('-overwrite -q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$resize_param.' -crop '.$offset_x.' '.$offset_y.' '.$CONF['DIMthumbnail'].' '.$CCT_dimthumbnail.' -rmeta -rexifthumb "'.$CCT_filesource.'"');
    
    $BlockThumbnail['create_custom_thumbs'] = true;
    $CCT_filesource = $file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg';
  }

  // Cadre autour de la miniature
  if ($CCT_frameparams['size1'] != 0 OR $CCT_frameparams['size2'] != 0) {
    // Si la miniature n'a pas encore été générée il faut le faire
    if ($CCT_filesource == $FilesSource[$i]) {
      nconvert('-q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
      $CCT_filesource = $file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg';
    }

    $img = imagecreatefromjpeg($CCT_filesource);
    $x = imagesx($img)-1;
    $y = imagesy($img)-1;
    
    $colors[0] = hex2RGB($CCT_frameparams['color1']);
    $colors[1] = hex2RGB($CCT_frameparams['color2']);
    $colors[0] = imagecolorallocate($img, $colors[0]['r'], $colors[0]['g'], $colors[0]['b']);
    $colors[1] = imagecolorallocate($img, $colors[1]['r'], $colors[1]['g'], $colors[1]['b']);

    for ($m=0; $m<$CCT_frameparams['size1']; $m++) {
      imagerectangle($img, $m, $m, $x-$m, $y-$m, $colors[0]);
    }
    for ($m=$CCT_frameparams['size1']; $m<$CCT_frameparams['size1']+$CCT_frameparams['size2']; $m++) {
      imagerectangle($img, $m, $m, $x-$m, $y-$m, $colors[1]);
    }
    
    imagejpeg($img, $file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg', $CONF['Qthumbnail']);
    imagedestroy($img);
    
    $BlockThumbnail['create_custom_thumbs'] = true;
    $CCT_filesource = $file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg';
  }
}

}
?>